//====================================================
// Glass
//====================================================
// By EVOLVED
// www.evolved-software.com
//====================================================
#include "DarkGDK.h"

void DarkGDK()
{

	//Set Up Display
	    int Sw=GetSystemMetrics(0);
		int Sh=GetSystemMetrics(1);
		dbSetWindowOff();
		dbSetDisplayModeVSync(Sw,Sh,32,1);
		dbSyncOn();
		dbSyncRate(0);

	//Set Text
		dbSetTextFont("Verdana");
		dbSetTextSize(15);
		dbSetTextToBold();
		dbInk(dbRGB(200,200,0),0);
		char ScreenFPS[32];
		int nopress=0;

    //Setup Camera
		dbHideMouse();
		dbAutoCamOff();
		dbColorBackdrop(dbRGB(128,128,128));
		dbSetCameraFOV(85);
		dbXRotateCamera(30);
		float CamDis=-100.0;

	//Setup Refraction Camera
		dbMakeCamera(1);
		dbSetCameraRange(1,1,15000);
		dbSetCameraFOV(1,85);
		dbSetCameraAspect(1,1.35);
		dbBackdropOff(1);
		dbSetCameraToImage(1,1,Sw/2,Sh/2);

	//Load Textures
		dbLoadImage("Media/Cube0.dds",2,2); int image=1;
		dbLoadImage("Media/Floor.dds",3);
	    dbLoadImage("Media/Floor_n.dds",4);

	//Create Object
		dbLoadEffect("FX/Refraction Reflection.fx",1,0); 
		dbLoadObject("Media/ast4.X",1); int object=1;
		dbTextureObject(1,0,1);
		dbTextureObject(1,1,2);
		dbSetObjectEffect(1,1);
		int rotate=0;

	//Mask object to camera 0		
		sObject *ObjPtr=dbGetObject(1);
		ObjPtr->dwCameraMaskBits=(1 << 0);
		ObjPtr=NULL;

	//Create floor
		dbLoadEffect("FX/EnvironmentBump.fx",2,0);
		dbMakeObjectBox(2,500,1,500);
		dbPositionObject(2,0,-65,0);
		dbTextureObject(2,0,3);
		dbTextureObject(2,1,4);
		dbTextureObject(2,2,2);
		dbScaleObjectTexture(2,0,5,5);
		dbSetObjectEffect(2,2);

	//Create Sky
		dbMakeObjectSphere(3,2000,5,5);
		dbSetObjectCull(3,0);
		dbTextureObject(3,0,2);
		dbLoadEffect("FX/SkyBox.fx",3,0);
		dbSetObjectEffect(3,3);

//Start loop
	while(LoopGDK())
	{

	//Control Camera
		dbPositionCamera(0,0,0);
        if(dbMouseClick()==0)
		{
			dbXRotateCamera(dbCameraAngleX(0)-dbMouseMoveY()*0.25);
            dbYRotateCamera(dbCameraAngleY(0)+dbMouseMoveX()*0.25);
            if(dbCameraAngleX(0)>80) dbXRotateCamera(0,80);
            if(dbCameraAngleX(0)<-60) dbXRotateCamera(0,-60);
		}
        if(dbMouseClick()>0) CamDis=CamDis-dbMouseMoveY()*0.25;
        CamDis=CamDis+dbMouseMoveZ()*0.25;
		if(dbUpKey()==1 || dbKeyState(17)==1) CamDis=CamDis+2.5;
		if(dbDownKey()==1 || dbKeyState(31)==1) CamDis=CamDis+2.5;
        if(CamDis>-20) CamDis=-20;
        if(CamDis<-300) CamDis=-300;
        dbMoveCamera(0,CamDis);
        if(dbCameraPositionY()<-60) dbPositionCamera(dbCameraPositionX(),-60,dbCameraPositionZ());
		dbMouseMoveX();
		dbMouseMoveY();
		dbPositionCamera(1,dbCameraPositionX(),dbCameraPositionY(),dbCameraPositionZ());
		dbRotateCamera(1,dbCameraAngleX(),dbCameraAngleY(),dbCameraAngleZ());

	//Rotate object
		if(dbKeyState(19)==1 && rotate==1 && nopress==0) {rotate=0;nopress=1;}
		if(dbKeyState(19)==1 && rotate==0 && nopress==0) {rotate=1;nopress=1;}
		if(rotate==0) dbRotateObject(1,0,dbObjectAngleY(1)+0.5,0);	

	//Change Texture
		if(dbKeyState(20)==1 && nopress==0)
		{
			dbDeleteImage(2);
            image++;
            if(image>3) image=1;
            if(image==1) dbLoadImage("Media/Cube0.dds",2,2);
            if(image==2) dbLoadImage("Media/Cube1.dds",2,2);
            if(image==3) dbLoadImage("Media/Cube2.dds",2,2);
            dbTextureObject(1,1,2);
            dbTextureObject(2,2,2);
			dbTextureObject(3,0,2);
			nopress=1;
		}

	//Change Object
		 if(dbSpaceKey()==1 && nopress==0)
		 {
			dbDeleteObject(1);
            object++;
			if(object>6) object=1;
			if(object==1) dbLoadObject("Media/ast4.x",1);
			if(object==2) {dbLoadObject("Media/t-pot.x",1);dbScaleObject(1,4000,4000,4000);dbScaleObjectTexture(1,4,2);}
			if(object==3) {dbLoadObject("Media/Tosus.x",1);dbScaleObjectTexture(1,0,1.5,1);}
			if(object==4) dbMakeObjectBox(1,75,75,75);
			if(object==5) {dbMakeObjectSphere(1,75,40,40);dbScaleObjectTexture(1,0,2,1);}
			if(object==6) {dbMakeObjectCylinder(1,75);dbScaleObjectTexture(1,0,3,1);} 
			sObject *ObjPtr=dbGetObject(1);
			ObjPtr->dwCameraMaskBits=(1 << 0);
			ObjPtr=NULL;
			dbTextureObject(1,0,1);
            dbTextureObject(1,1,2);
            dbSetObjectEffect(1,1);
			nopress=1;
		}
		if(dbScanCode()==0) nopress=0;

	//Screen Fps text
		sprintf(ScreenFPS,"Screen FPS = %i",dbScreenFPS());
		dbCenterText(Sw/2,15,"T - Change Texture      Space - Change Object      R - Rotate Object");
		dbCenterText(Sw/2,40,ScreenFPS);

	//Sync for Refraction Camera
		dbSyncMask(1 << 1);
		dbFastSync();

	//Sync for Main Camera
		dbSyncMask(1 << 0);
		dbSync();
 
	}
}